package net.mcreator.jays_mod;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.EntityRegistry;
import net.minecraftforge.fml.common.registry.EntityEntryBuilder;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.common.DungeonHooks;

import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.DamageSource;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.passive.EntityWolf;
import net.minecraft.entity.passive.EntitySquid;
import net.minecraft.entity.passive.EntityParrot;
import net.minecraft.entity.passive.EntityOcelot;
import net.minecraft.entity.monster.EntitySpider;
import net.minecraft.entity.monster.EntityGuardian;
import net.minecraft.entity.ai.EntityAIWander;
import net.minecraft.entity.ai.EntityAISwimming;
import net.minecraft.entity.ai.EntityAIPanic;
import net.minecraft.entity.ai.EntityAIOpenDoor;
import net.minecraft.entity.ai.EntityAINearestAttackableTarget;
import net.minecraft.entity.ai.EntityAIMoveIndoors;
import net.minecraft.entity.ai.EntityAILookIdle;
import net.minecraft.entity.ai.EntityAILeapAtTarget;
import net.minecraft.entity.ai.EntityAIHurtByTarget;
import net.minecraft.entity.ai.EntityAIFollow;
import net.minecraft.entity.ai.EntityAIEatGrass;
import net.minecraft.entity.ai.EntityAIAvoidEntity;
import net.minecraft.entity.ai.EntityAIAttackMelee;
import net.minecraft.entity.SharedMonsterAttributes;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.EnumCreatureAttribute;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.model.ModelSpider;

import java.util.HashMap;

@Elementsjays_mod.ModElement.Tag
public class MCreatorTropicalSpider extends Elementsjays_mod.ModElement {
	public static final int ENTITYID = 40;
	public static final int ENTITYID_RANGED = 41;

	public MCreatorTropicalSpider(Elementsjays_mod instance) {
		super(instance, 466);
	}

	@Override
	public void initElements() {
		elements.entities.add(() -> EntityEntryBuilder.create().entity(EntityCustom.class)
				.id(new ResourceLocation("jays_mod", "tropicalspider"), ENTITYID).name("tropicalspider").tracker(64, 1, true).egg(-6697984, -6711040)
				.build());
	}

	@Override
	public void init(FMLInitializationEvent event) {
		Biome[] spawnBiomes = {Biome.REGISTRY.getObject(new ResourceLocation("jays_mod:tropical")),
				Biome.REGISTRY.getObject(new ResourceLocation("jays_mod:tropicsgrasslands")),
				Biome.REGISTRY.getObject(new ResourceLocation("jays_mod:tropicalocean")),};
		EntityRegistry.addSpawn(EntityCustom.class, 1, 1, 1, EnumCreatureType.CREATURE, spawnBiomes);
		DungeonHooks.addDungeonMob(new ResourceLocation("jays_mod:tropicalspider"), 180);
	}

	@SideOnly(Side.CLIENT)
	@Override
	public void preInit(FMLPreInitializationEvent event) {
		RenderingRegistry.registerEntityRenderingHandler(EntityCustom.class, renderManager -> {
			return new RenderLiving(renderManager, new ModelSpider(), 1f) {
				protected ResourceLocation getEntityTexture(Entity entity) {
					return new ResourceLocation("jays_mod:textures/tropical_spider.png");
				}
			};
		});
	}

	public static class EntityCustom extends EntitySpider {
		public EntityCustom(World world) {
			super(world);
			setSize(1.4f, 0.9f);
			experienceValue = 30;
			this.isImmuneToFire = false;
			setNoAI(!true);
			this.tasks.addTask(1, new EntityAIAvoidEntity(this, EntityOcelot.class, (float) 15, 1, 1));
			this.tasks.addTask(2, new EntityAIAvoidEntity(this, EntityGuardian.class, (float) 15, 1, 1));
			this.tasks.addTask(3, new EntityAIOpenDoor(this, true));
			this.tasks.addTask(4, new EntityAIAttackMelee(this, 1.2, true));
			this.targetTasks.addTask(5, new EntityAIHurtByTarget(this, true));
			this.targetTasks.addTask(6, new EntityAINearestAttackableTarget(this, EntityPlayer.class, true, true));
			this.targetTasks.addTask(7, new EntityAINearestAttackableTarget(this, EntityParrot.class, true, true));
			this.targetTasks.addTask(8, new EntityAINearestAttackableTarget(this, EntityWolf.class, true, true));
			this.targetTasks.addTask(9, new EntityAINearestAttackableTarget(this, EntitySquid.class, true, true));
			this.tasks.addTask(10, new EntityAILeapAtTarget(this, (float) 1.5));
			this.tasks.addTask(11, new EntityAIWander(this, 0.5));
			this.tasks.addTask(12, new EntityAIFollow(this, (float) 0.8, 25, 5));
			this.tasks.addTask(13, new EntityAILookIdle(this));
			this.tasks.addTask(14, new EntityAISwimming(this));
			this.tasks.addTask(15, new EntityAIPanic(this, 0.5));
			this.tasks.addTask(16, new EntityAIEatGrass(this));
			this.tasks.addTask(17, new EntityAIMoveIndoors(this));
		}

		@Override
		public EnumCreatureAttribute getCreatureAttribute() {
			return EnumCreatureAttribute.ARTHROPOD;
		}

		@Override
		protected Item getDropItem() {
			return new ItemStack(MCreatorTropicalString.block, (int) (1)).getItem();
		}

		@Override
		public net.minecraft.util.SoundEvent getAmbientSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(
					"jays_mod:TropicalSpider_Idle"));
		}

		@Override
		public net.minecraft.util.SoundEvent getHurtSound(DamageSource ds) {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(
					"jays_mod:TropicalSpider_Hurt"));
		}

		@Override
		public net.minecraft.util.SoundEvent getDeathSound() {
			return (net.minecraft.util.SoundEvent) net.minecraft.util.SoundEvent.REGISTRY.getObject(new ResourceLocation(
					"jays_mod:TropicalSpider_Death"));
		}

		@Override
		protected float getSoundVolume() {
			return 1.0F;
		}

		@Override
		public boolean attackEntityFrom(DamageSource source, float amount) {
			if (source == DamageSource.CACTUS)
				return false;
			if (source == DamageSource.DROWN)
				return false;
			return super.attackEntityFrom(source, amount);
		}

		@Override
		public void onDeath(DamageSource source) {
			super.onDeath(source);
			int x = (int) this.posX;
			int y = (int) this.posY;
			int z = (int) this.posZ;
			Entity entity = this;
			{
				java.util.HashMap<String, Object> $_dependencies = new java.util.HashMap<>();
				$_dependencies.put("x", x);
				$_dependencies.put("y", y);
				$_dependencies.put("z", z);
				$_dependencies.put("world", world);
				MCreatorTropicalSpiderDrops.executeProcedure($_dependencies);
			}
		}

		@Override
		protected void applyEntityAttributes() {
			super.applyEntityAttributes();
			if (this.getEntityAttribute(SharedMonsterAttributes.ARMOR) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ARMOR).setBaseValue(0D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MOVEMENT_SPEED).setBaseValue(0.35D);
			if (this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH) != null)
				this.getEntityAttribute(SharedMonsterAttributes.MAX_HEALTH).setBaseValue(50D);
			if (this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE) != null)
				this.getEntityAttribute(SharedMonsterAttributes.ATTACK_DAMAGE).setBaseValue(30D);
		}

		protected void dropRareDrop(int par1) {
			this.dropItem(new ItemStack(MCreatorRuby.block, (int) (1)).getItem(), 1);
		}
	}
}
